#!/usr/bin/env ruby

require 'thor'
require 'json'

require_relative 'mist/services'
require_relative 'mist/client'

class Mist < Thor

  desc "start SERVICE", "Default cheapest machine of given service"
  desc "config SERVICE", "Creates configuration file for new cloud compute provider in ~/.mist/TITLE"

  def config(service)
    case service
      when 'aws','AWS','Amazon Web Services'
        @config = Client.get_config

        say("MIST => Amazon Web Services EC2 Setup")
        public_key = ask("Public Key: ")
        private_key = ask("Secret Key: ")

        puts @config

        @config[:services] = {
            :aws => {
                :public_key => public_key,
                :private_key => private_key
            }
        }

        Client.set_config @config
      else
        puts "That service schema was not recognized."
    end
  end

  def start(machine)
    Services.new(:boot => machine)
  end

  def cheapest
    # Scan for cheapest available machine (EC2 market)
  end

end

Mist.start

Client.setup



